const base = require('@savoygu/eslint-config-base')

module.exports = {
  extends: [
    '@savoygu/eslint-config-base',
    'plugin:import/typescript',
    'plugin:@typescript-eslint/recommended'
  ],
  ignorePatterns: ['*.d.ts'],
  settings: {
    'import/resolver': {
      node: { extensions: ['.js', '.jsx', '.mjs', '.ts', '.tsx', '.d.ts'] }
    }
  },
  overrides: [
    ...base.overrides,
    {
      files: ['*.d.ts'],
      rules: {
        'import/no-duplicates': 'off'
      }
    },
    {
      files: ['*.js'],
      rules: {
        '@typescript-eslint/no-var-requires': 'off'
      }
    },
    {
      files: ['*.test.ts', '*.spec.ts'],
      rules: {
        'no-unused-expressions': 'off'
      }
    }
  ],
  rules: {
    // Disallow variable declarations from shadowing variables declared in the outer scope.
    // Disallow the use of variables before they are defined.
    'no-use-before-define': 'off',
    '@typescript-eslint/no-use-before-define': ['error'],

    // Disallow non-null assertions using the ! postfix operator.
    '@typescript-eslint/no-non-null-assertion': 'off',
    //  Disallow certain types
    '@typescript-eslint/ban-types': 'off',
    //  Disallow the any type
    '@typescript-eslint/no-explicit-any': 'off'
  }
}
